#include <v_lib.h>

void somelongop()
{
	/*
	 * Solution of linear system of order 2000
	 */
#define	N 2000
	int i;
	matrix_p a;
	vector_p b, x;
	a = matAlloc(N,N);
	b = vecAlloc(N);
	matUnit(a);
	for(i=0;i<N;++i)
		b->elements[i] = i;
/* FIXME: look for spinlock HERE! */
	x = matSolve(a,b,false);
	memFree(x);
}

volatile int spinlock = 1;

void V_CALL th(void *arg)
{
	while(spinlock);
	somelongop();
}

#define	MAX_THR	24

int main(int argc,char *argv[])
{
	unsigned ms, single;
	unsigned i, num_threads;
	vhandle_t threads[MAX_THR];
	logStartConsoleLog();
	logUpperLevel(LOG_TRACE);
	ms = timeTickCount();
	puts("begins sequential execution");
	somelongop();
	single = timeTickCount() - ms;
	printf("Sequential exec of one thread: %u ms\n", single);
	puts("Parallel exec:\nthreads;ms_total;effectivness");
	for(num_threads = 2;num_threads <= MAX_THR;num_threads++)
	{
		for(i = 0;i < num_threads;i++)
			threads[i] = threadCreate(th,NULL);
		ms = timeTickCount();
		spinlock = 0;
		for(i = 0;i < num_threads;i++)
			threadJoin(threads[i],NULL);
		ms = timeTickCount() - ms;
		printf("%u;%u;%g\n", num_threads, ms, (double)single / ms);
	}
	memPrintStats();
	return 0;
}
